EnlargeFieldYield = {};

function EnlargeFieldYield:loadMap(name)
	EnlargeFieldYield.settingsDir = getUserProfileAppPath().. "modsSettings/EnlargeFieldYield/";

	EnlargeFieldYield:PrepareSettings();

	EnlargeFieldYield:ApplySettings();

end;


function EnlargeFieldYield:mouseEvent(posX, posY, isDown, isUp, button)
end;


function EnlargeFieldYield:keyEvent(unicode, sym, modifier, isDown)
end;


function EnlargeFieldYield:update(dt)
end;


function EnlargeFieldYield:draw(dt)
end;

function EnlargeFieldYield:PrepareSettings()
	createFolder(getUserProfileAppPath() .. "modsSettings/");
	createFolder(EnlargeFieldYield.settingsDir);
	local file = EnlargeFieldYield.settingsDir.. "enlargeFieldYieldSettings.xml";
	
	if not fileExists(file) then
		local xmlContent = createXMLFile("EnlargeFieldYieldSettings_XML", file, "enlargeFieldYieldSettings");		

		-- Fruit Types

		--WHEAT
		local pos = 0;		
		local rootPath = "enlargeFieldYieldSettings.fruitTypes";
		local groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "WHEAT", 0.04, 8.9, 0.05, 0.89); -- x2

		--BARLEY
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "BARLEY", 0.04, 7.68, 0.05, 0.96); -- x2

		--OAT
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "OAT", 0.04, 3.42, 0.05, 0.57); -- x2

		--COTTON
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "COTTON", 0.04, 0.994, 0.05, 0.497); -- x2

		--CANOLA
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		setXMLString(Xml, groupNameTag .. "#name", "CANOLA");
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "CANOLA", 0.02, 3.48, 0.02, 0.58); -- x2

		--SUNFLOWER
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);		
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "SUNFLOWER", 0.03, 2.08, 0.03, 0.52); -- x2

		--SOYBEAN
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "SOYBEAN", 0.03, 4.5, 0.03, 0.45); -- x2

		--MAIZE
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "MAIZE", 0.04, 5.7, 0.04, 0.92);  -- x2

		--POTATO
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "POTATO", 0.4, 8.26, 0.38, 4.13); -- x2

		--SUGARBEET
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "SUGARBEET", 0.04, 11.56, 0.04, 5.78); -- x2

		--OILSEEDRADISH
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "OILSEEDRADISH", 0.01, 1.98, 0.01, 0.99); -- x2

		--POPLAR
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "POPLAR", 0.15, 5.64, 0.15, 2.82); -- x2

		--SUGARCANE
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "SUGARCANE", 1.20, 22.68, 1.20, 11.34); -- x2

		--GRASS
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "GRASS", 0.03, 26.22, 0.03, 4.37); -- x2

		--DRYGRASS
		pos = pos + 1;
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, "DRYGRASS", 0.02, 26.22, 0.02, 4.37); -- x2


		-- Spray Types
		
		-- FERTILIZER
		pos = 0;		
		rootPath = "enlargeFieldYieldSettings.sprayTypes";
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "FERTILIZER", 0.0050, 0.0060);

		-- LIQUIDFERTILIZER
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "LIQUIDFERTILIZER", 0.0060, 0.0081);

		-- MANURE
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "MANURE", 0.1000, 0.4000);

		-- LIQUIDMANURE
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "LIQUIDMANURE", 0.0500, 0.4000);

		-- DIGESTATE
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "DIGESTATE", 0.1000, 0.4000);

		-- LIME
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "LIME", 0.0500, 0.0900);

		-- HERBICIDE
		pos = pos + 1;
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);
		EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, "HERBICIDE", 0.0050, 0.0081);


		saveXMLFile(xmlContent);	

	end;
end;

function EnlargeFieldYield:ApplySettings()
	local fruitTypes = {
		"WHEAT", 
		"BARLEY",
		"OAT",
		"COTTON",
		"CANOLA",
		"SUNFLOWER",
		"SOYBEAN",
		"MAIZE",
		"POTATO",
		"SUGARBEET",
		"OILSEEDRADISH",
		"POPLAR",
		"SUGARCANE",
		"GRASS",
		"DRYGRASS"
	};

	local sprayTypes = {
		"FERTILIZER", 
		"LIQUIDFERTILIZER",
		"MANURE",
		"LIQUIDMANURE",
		"DIGESTATE",
		"LIME",
		"HERBICIDE"
	};

	local file = EnlargeFieldYield.settingsDir.. "enlargeFieldYieldSettings.xml";
	local xmlContent = loadXMLFile("EnlargeFieldYieldSettings_XML", file, "enlargeFieldYieldSettings");

	-- apply fruit types 
	local pos = 0;
	local rootPath = "enlargeFieldYieldSettings.fruitTypes";
	local groupNameTag = "";

	for _, frType in pairs(fruitTypes) do
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);		
		
		local fruitXmlName = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#name"), "");
		local fruitXmlSeedUsage = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#seedUsagePerSqm"), -1);
		local fruitXmlLiters = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#literPerSqm"), -1);

		if fruitXmlName ~= "" and fruitXmlSeedUsage ~= -1 and fruitXmlLiters ~= -1 then 
			local ft = g_fruitTypeManager:getFruitTypeByName(fruitXmlName);

			if ft ~= nil then			
				ft.seedUsagePerSqm = fruitXmlSeedUsage;
				ft.literPerSqm = fruitXmlLiters;

				print(string.format("Apply new values for FruitType name - %s, seedUsagePerSqm - %s, literPerSqm - %s", fruitXmlName, fruitXmlSeedUsage, fruitXmlLiters));				

			end;
		end;

		pos = pos + 1;		

	end;

	-- apply spray types
	pos = 0;
	rootPath = "enlargeFieldYieldSettings.sprayTypes";	

	for _, spType in pairs(sprayTypes) do
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);		
		
		local sprayXmlName = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#name"), "");
		local sprayXmlLitersUsage = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#litersPerSecond"), -1);		

		if sprayXmlName ~= "" and sprayXmlLitersUsage ~= -1 then 
			local sp = g_sprayTypeManager:getSprayTypeByName(sprayXmlName);

			if sp ~= nil then			
				sp.litersPerSecond = sprayXmlLitersUsage;				

				print(string.format("Apply new values for SprayType name - %s, litersPerSecond - %s", sprayXmlName, sprayXmlLitersUsage));				

			end;
		end;

		pos = pos + 1;		

	end;	

end;

function EnlargeFieldYield:BuildFruitTypeXMLNode(xmlContent, groupNameTag, cropName, seedUsage, litersOutput, defaultSeedUsage, defaultLitersOutput)
	setXMLString(xmlContent, groupNameTag .. "#name", cropName);
	setXMLFloat(xmlContent,  groupNameTag .. "#seedUsagePerSqm", seedUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#literPerSqm", litersOutput);	
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultSeedUsagePerSqm", defaultSeedUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultLiterPerSqm", defaultLitersOutput);	
end;

function EnlargeFieldYield:BuildSprayTypeXMLNode(xmlContent, groupNameTag, sprayName, litersUsage, defaultLitersUsage)
	setXMLString(xmlContent, groupNameTag .. "#name", sprayName);
	setXMLFloat(xmlContent,  groupNameTag .. "#litersPerSecond", litersUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultLitersPerSecond", defaultLitersUsage);	
end;

addModEventListener(EnlargeFieldYield);